/*
 * Copyright (c) 2000-2009 TeamDev Ltd. All rights reserved.
 * TeamDev PROPRIETARY and CONFIDENTIAL.
 * Use is subject to license terms.
 */

package com.teamdev.xpcom.mozilla.demo.components.icon.linux;

import com.teamdev.xpcom.mozilla.demo.components.icon.IconLoader;
import com.teamdev.xpcom.mozilla.demo.components.icon.JavaImage;
import com.jniwrapper.util.Logger;

import javax.swing.*;
import java.io.IOException;
import java.awt.*;
import java.awt.image.BufferedImage;

public class FavIcon implements IconLoader {
    private static final String FAVORITE_ICON_FILE = "/favicon.ico";
    public static final int PREFERRED_SIZE = 16;
    private static final Dimension PREFERRED_DIMENSION = new Dimension(PREFERRED_SIZE, PREFERRED_SIZE);
    private static final Logger LOG = Logger.getInstance(FavIcon.class);

    public FavIcon() {

    }

    public javax.swing.Icon loadFromURL(String url) {
        try {
            String urlToImage = url + FAVORITE_ICON_FILE;
            if (JavaImage.isJavaSupportImage(urlToImage)) {
                JavaImage javaImage = new JavaImage(url + FAVORITE_ICON_FILE);
                BufferedImage bufferedImage = (BufferedImage)javaImage.getImage();
                Dimension iconDimesion = new Dimension(bufferedImage.getHeight(), bufferedImage.getWidth());
                Image image;
                if (iconDimesion.equals(PREFERRED_DIMENSION)) {
                    image = bufferedImage;
                } else {
                    image = bufferedImage.getScaledInstance(PREFERRED_SIZE, PREFERRED_SIZE, Image.SCALE_REPLICATE);
                }
                return new ImageIcon(image);
            }
        } catch (IOException e) {
            LOG.info("Favicon can not load for url: " + url);
            return null;
        }
        return null;
    }
}
