/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * d:/Mozilla/mozilla/toolkit/components/url-classifier/public/nsIUrlClassifierDBService.idl
 */

package org.mozilla.interfaces;

/**
 * The nsIUrlClassifierUpdateObserver interface is implemented by
 * clients streaming updates to the url-classifier (usually
 * nsUrlClassifierStreamUpdater.
 */
public interface nsIUrlClassifierUpdateObserver extends nsISupports {

  String NS_IURLCLASSIFIERUPDATEOBSERVER_IID =
    "{bbb33c65-e783-476c-8db0-6ddb91826c07}";

  /**
   * The update requested a new URL whose contents should be downloaded
   * and sent to the classifier as a new stream.
   *
   * @param url The url that was requested.
   * @param table The table name that this URL's contents will be associated
   *              with.  This should be passed back to beginStream().
   * @param serverMAC The server-supplied MAC of the data at this URL.  This
   *                  should be passed back to beginStream().
   */
  void updateUrlRequested(String url, String table, String serverMAC);

  /**
   * The server has requested that the client get a new client key for
   * MAC requests.
   */
  void rekeyRequested();

  /**
   * A stream update has completed.
   *
   * @param status The state of the update process.
   * @param delay The amount of time the updater should wait to fetch the
   *              next URL in ms.
   */
  void streamFinished(long status, long delay);

  void updateError(long error);

  /**
   * The update has completed successfully.
   *
   * @param requestedTimeout The number of seconds that the caller should
   *                         wait before trying to update again.
   **/
  void updateSuccess(long requestedTimeout);

}